/**
 * Property Mapping:
 *     Layout.Text0 URL
 **/

function SquirroDashboard_Widget(qv) {
    this.DEBUG = false;
    this.render(qv);
}

SquirroDashboard_Widget.prototype.render = function (qv) {
    var that = this;

    if (qv && this.qv !== qv) {
        // Re-render if it's a new QV context…
        this.el = null;
        this.qv = qv;
        this.$qv = $(qv.Element);

        // This is a big ugly fugly hack to prevent exceptions when hiding
        // the dashboard.
        // On Internet Explorer hiding the extension container will trigger
        // an iFrame resize event. That in turn will cause us to start
        // calculations that won't work if the calculated with is 0.
        // The real fix will probably have to happen on the server side.
        var parent = this.$qv.parent('[extension=on]');
        if (parent) {
            parent[0].addEventListener('DOMAttrModified', function (ev) {
                if (!that.$qv.is(':visible')) {
                    that.url = null;
                    that.$qv.html('');
                }
            });
        }
    }

    if (this.$qv.is(':visible')) {
        this._renderIFrame();
    }
};

SquirroDashboard_Widget.prototype._renderIFrame = function () {
    var params = this._getParams();

    if (!params.url) {
        return;
    }

    if (! this.el || this.url !== params.url || this.query !== params.query || this.created_after !== params.created_after || this.created_before !== params.created_before || this.token !== params.token) {
        var url = params.url,
            urlParams = {},
            key, value;
        for (key in params) {
            value = params[key];
            if (key !== 'url' && params.hasOwnProperty(key) && value) {
                urlParams[key] = params[key];
            }
        }
        var fullUrl = url + '?' + $.param(urlParams);

        this.el = $('<div class="squirro-dashboard"><iframe src="' +  fullUrl + '" width="100%" height="100%" frameborder="0"></iframe></div>');
        this.$qv.html(this.el);
        this.$el = $(this.el);
        this.url = url;
        this.query = params.query;
        this.created_after = params.created_after;
        this.created_before = params.created_before;
        this.token = params.token;
    }
};


/**
 * Returns the extension's configuration.
 */
SquirroDashboard_Widget.prototype._getParams = function () {
    return {
        url: this._getValue(0),
        token: this._getValue(1),
        query: this._getValue(2),
        created_after: this._getValue(3),
        created_before: this._getValue(4)
    };
};

/**
 * Returns configuration options of a given index.
 */
SquirroDashboard_Widget.prototype._getValue = function (idx) {
    var data = this.qv.Layout['Text' + idx],
        retval = null;
    if (data && data.text && data.text !== '-') {
        retval = $.trim(data.text);
    }
    return retval;
};
